Index: libc/arch/ia64/Makefile.inc
===================================================================
--- libc/arch/ia64/Makefile.inc	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
+++ libc/arch/ia64/Makefile.inc	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
@@ -0,0 +1,38 @@
+#
+# Copyright (C) 2005 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+## Toolchain configuration
+#
+
+TARGET = ia64-pc-linux-gnu
+TOOLCHAIN_DIR = /usr/local/ia64/bin
+CFLAGS += -fno-unwind-tables
+LFLAGS +=
+AFLAGS += 
+
+ARCH_SOURCES += arch/$(ARCH)/src/syscall.c
Index: libc/arch/ia64/_link.ld.in
===================================================================
--- libc/arch/ia64/_link.ld.in	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
+++ libc/arch/ia64/_link.ld.in	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
@@ -0,0 +1,23 @@
+OUTPUT_FORMAT(elf64-ia64-little)
+STARTUP(../libc/arch/ARCH/src/entry.o)
+ENTRY(__entry)
+
+SECTIONS {
+	.text 0x00004000 : {
+		*(.text)
+		*(.rodata .rodata.*)
+		*(.opd)
+		*(.data)
+		*(.got .got.*)
+		*(.sdata)
+		*(.sbss)
+		*(.scommon)
+		*(.bss)
+		*(COMMON);
+	}
+ 
+	/DISCARD/ : {
+		*(.note.GNU-stack);
+		*(.comment);
+        }
+}
Index: libc/arch/ia64/include/types.h
===================================================================
--- libc/arch/ia64/include/types.h	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
+++ libc/arch/ia64/include/types.h	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
@@ -0,0 +1,36 @@
+/*
+ * Copyright (C) 2006 Ondrej Palkovsky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef __LIBC__TYPES_H__
+#define __LIBC__TYPES_H__
+
+typedef unsigned long long sysarg_t;
+typedef unsigned int size_t;
+typedef signed int ssize_t;
+
+#endif
Index: libc/arch/ia64/src/entry.s
===================================================================
--- libc/arch/ia64/src/entry.s	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
+++ libc/arch/ia64/src/entry.s	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
@@ -0,0 +1,42 @@
+#
+# Copyright (C) 2006 Jakub Jermar
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+.text
+
+.org 0
+
+.globl __entry
+
+## User-space task entry point
+#
+#
+__entry:
+	br.call.sptk.many b0 = main
+	br.call.sptk.many b0 = __exit
+	
+.end __entry
Index: libc/arch/ia64/src/syscall.c
===================================================================
--- libc/arch/ia64/src/syscall.c	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
+++ libc/arch/ia64/src/syscall.c	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (C) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <libc.h>
+
+sysarg_t __syscall(const syscall_t id, const sysarg_t p1, const sysarg_t p2, const sysarg_t p3)
+{
+	sysarg_t ret;
+	
+	__asm__ volatile (
+		"mov r14 = %1\n"
+		"mov r15 = %2\n"
+		"mov r16 = %3\n"
+		"mov r17 = %4\n"
+		"break 0\n"
+		"mov %0 = r8\n"
+		: "=r" (ret)
+		: "r" (id), "r" (p1), "r" (p2), "r" (p3)
+		: "r8", "r14", "r15", "r16"
+	);
+	
+	return ret;
+}
Index: uspace.config
===================================================================
--- uspace.config	(revision f37d76960a21f813d1cf24c92836f45c8dfc151a)
+++ uspace.config	(revision fbd6f810551695e266448f9cbc2ca84be4bcaeeb)
@@ -3,4 +3,5 @@
 # Architecture
 @ "ia32" Intel IA-32
+@ "ia64" Intel IA-64
 @ "amd64" AMD64/Intel EM64T
 @ "mips32" MIPS 32-bit Little Endian
